/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: inheritnode.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/16 16:32:21 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_autodoc.hxx"

#include <precomp.h>
#include <ary/inheritnode.hxx>


// NOT FULLY DECLARED SERVICES


namespace ary
{
namespace inherit
{

Node::Node( const String &          i_name,
            Rid                     i_ce )
    :   aBases(),
        nCountBases(0),
        aDerivates(),
        nCountDerivates(0),
        sName(i_name),
        nCodeEntity(i_ce)
{
}

Node::~Node()
{
}

void
Node::Join( DYN Node &          io_base,
            DYN Node &          io_derived )
{
    io_base.aDerivates.push_back(&io_derived);
    io_base.UpdateDerivatesCount(io_derived.nCountDerivates + 1);

    io_derived.aBases.push_back(&io_base);
    io_derived.UpdateBasesCount(io_base.nCountBases + 1);
}

void
Node::UpdateBasesCount( intt i_difference )
{
    nCountBases += i_difference;

    for ( Iterator it = aDerivates.begin();
		  it != aDerivates.end();
		  ++it )
    {
        (*it)->UpdateBasesCount(i_difference);
    }
}


void
Node::UpdateDerivatesCount( intt i_difference )
{
    nCountDerivates += i_difference;

    for ( Iterator it = aBases.begin();
		  it != aBases.end();
		  ++it )
    {
        (*it)->UpdateDerivatesCount(i_difference);
    }
}



}   // namespace ary
}   // namespace inherit
