/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: codeinf2.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/16 16:38:53 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_autodoc.hxx"


#include <precomp.h>
#include <ary_i/codeinf2.hxx>


// NOT FULLY DEFINED SERVICES

namespace ary
{
namespace info
{

CodeInformation::CodeInformation()
    :   aShort(),
        aDescription(),
        aDeprecatedText(),
        aTags(),
        pExternShort(0),
        bIsPublished(false),
        bIsDeprecated(false),
        bIsOptional(false)
{
}

CodeInformation::~CodeInformation()
{
}

void
CodeInformation::AddToken2DeprecatedText( DYN DocuToken & let_drToken )
{
    aDeprecatedText.AddToken(let_drToken);
}

ICid
CodeInformation::inq_InfoClassId() const
{
    return class_id;
}

namespace
{
    const ::ary::Information::InfoList
        aNull_Dummy;
}

const ::ary::Information::InfoList &
CodeInformation::inq_Children() const
{
    return aNull_Dummy;
}


}   // namespace info
}   // namespace ary
