/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: DatapointGeometry.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/17 13:35:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_chart2.hxx"
#ifndef _VIEW_DATAPOINTGEOMETRY_HXX
#include "DatapointGeometry.hxx"
#endif

//.............................................................................
namespace chart
{
using namespace ::com::sun::star;

//.............................................................................
DataPointGeometry::DataPointGeometry( const drawing::Position3D& rPosition
                    , const drawing::Direction3D& rSize )
                    : m_aPosition(rPosition)
                    , m_aSize(rSize)
                    , m_aSize2(0.0,0.0,0.0)
{

}

DataPointGeometry::DataPointGeometry( const drawing::Position3D& rPosition
                    , const drawing::Direction3D& rSize
                    , const drawing::Direction3D& rSize2 )
                    : m_aPosition(rPosition)
                    , m_aSize(rSize)
                    , m_aSize2(rSize2)
{

}

awt::Point DataPointGeometry::getPoint2D() const
{
    return awt::Point(m_aPosition.PositionX,m_aPosition.PositionY);
}

awt::Size  DataPointGeometry::getSize2D() const
{
    return awt::Size(m_aSize.DirectionX,m_aSize.DirectionY);
}

//.............................................................................
//.............................................................................
//.............................................................................

//.............................................................................
} //namespace chart
//.............................................................................
