/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: CKey.hxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 09:53:21 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef DBACCESS_CORE_API_KEY_HXX
#define DBACCESS_CORE_API_KEY_HXX

#ifndef CONNECTIVITY_TKEY_HXX
#include <connectivity/TKey.hxx>
#endif

namespace dbaccess
{
	class OTableKey : public connectivity::OTableKeyHelper
	{
		::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier > m_xKey;
	public:
		virtual void refreshColumns();
	public:
		OTableKey(	connectivity::OTableHelper* _pTable);
		OTableKey(	connectivity::OTableHelper* _pTable,
				const ::rtl::OUString& _Name,
				const ::rtl::OUString& _ReferencedTable,
				sal_Int32		_Type,
				sal_Int32		_UpdateRule,
				sal_Int32		_DeleteRule,
				const ::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier >& _rxKey = NULL
			);
	};
}
#endif // DBACCESS_CORE_API_KEY_HXX
