/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: CKeyColumns.hxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 09:54:25 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef DBACCESS_CORE_API_KEYCOLUMNS_HXX
#define DBACCESS_CORE_API_KEYCOLUMNS_HXX

#ifndef CONNECTIVITY_TKEYCOLUMNS_HXX
#include "connectivity/TKeyColumns.hxx"
#endif

namespace dbaccess
{
	class OKeyColumns : public connectivity::OKeyColumnsHelper
	{
		::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess > m_xColumns;
	protected:
        virtual connectivity::sdbcx::ObjectType createObject(const ::rtl::OUString& _rName);
	public:
		OKeyColumns(	connectivity::OTableKeyHelper* _pKey,
						::osl::Mutex& _rMutex,
						const ::std::vector< ::rtl::OUString> &_rVector,
						const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >& _rxColumns)
					: connectivity::OKeyColumnsHelper(_pKey,_rMutex,_rVector)
					,m_xColumns(_rxColumns)
		{
		}
	};
}
#endif // DBACCESS_CORE_API_KEYCOLUMNS_HXX
