/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: axisobj.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: ihi $ $Date: 2006/11/14 14:49:00 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SCH_AXISOBJ_HXX
#define _SCH_AXISOBJ_HXX

#include "chmod3d.hxx"
#include "schgroup.hxx"

class SchE3dObject;

class SchAxisObj : public SchObjGroup
{
public:
	TYPEINFO();

	SchAxisObj( ChartModel* = NULL );

	virtual void AddToHdlList(SdrHdlList& rHdlList) const;
	virtual sal_uInt32 GetHdlCount() const;
	virtual SdrHdl* GetHdl( sal_uInt32 ) const;
};

class Sch3dAxisObj : public SchE3dObject
{
public:
	TYPEINFO();

	Sch3dAxisObj();

	virtual void AddToHdlList(SdrHdlList& rHdlList) const;
};

#endif // _SCH_AXISOBJ_HXX

