/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tplabel.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 00:56:04 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SCH_TPAXIS_HXX
#define _SCH_TPAXIS_HXX

// header for SfxTabPage
#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif
// header for CheckBox
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#ifndef SVX_DIALCONTROL_HXX
#include <svx/dialcontrol.hxx>
#endif
#ifndef SVX_WRAPFIELD_HXX
#include <svx/wrapfield.hxx>
#endif
#ifndef SVX_ORIENTHELPER_HXX
#include <svx/orienthelper.hxx>
#endif

#include "attrib.hxx"

class SchAxisLabelTabPage : public SfxTabPage
{
private:
	CheckBox			aCbShowDescription;

    FixedLine           aFlOrient;
    svx::DialControl    aCtrlDial;
    FixedText           aFtRotate;
    svx::WrapField      aNfRotate;
    TriStateBox         aCbStacked;
    svx::OrientationHelper aOrientHlp;

	FixedLine			aFlTextFlow;
	CheckBox			aCbTextOverlap;
	CheckBox			aCbTextBreak;

	FixedLine			aFlOrder;
	RadioButton			aRbSideBySide;
	RadioButton			aRbUpDown;
	RadioButton			aRbDownUp;
	RadioButton			aRbAuto;

	FixedLine			aFlSeparator;

	OrderMode			eOrderMode;
	BOOL				bAllowTextOverlap;

    sal_Int32           m_nInitialDegrees;
    BOOL                m_bInitialStacking;

    DECL_LINK ( ToggleShowLabel, void* );

public:
	SchAxisLabelTabPage( Window* pParent, const SfxItemSet& rInAttrs );
	virtual ~SchAxisLabelTabPage();

	void	Construct();

	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rInAttrs );
	virtual BOOL FillItemSet( SfxItemSet& rOutAttrs );
	virtual void Reset( const SfxItemSet& rInAttrs );

	void SetOrderMode( OrderMode eMode );
	void AllowTextOverlap( BOOL bOverLap )		{ bAllowTextOverlap = bOverLap; }
};

#endif	// _SCH_TPAXIS_HXX

