#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.15 $
#
#   last change: $Author: hr $ $Date: 2006/10/24 14:15:42 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************
PRJ=..

PRJPCH=

PRJNAME=so3
TARGET=so2

# so2.hid generieren
GEN_HID=TRUE
GEN_HID_OTHER=TRUE

USE_LDUMP2=TRUE
LDUMP2=LDUMP3

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk
.INCLUDE :  $(PRJ)$/util$/makefile.pmk

RSCFLAGS+=-p

# --- Files --------------------------------------------------------


LIB1TARGET= $(SLB)$/$(TARGET).lib
LIB1FILES=\
		$(SLB)$/solink.lib		\
		$(SLB)$/dialog.lib		\
		$(SLB)$/data.lib		\
		$(SLB)$/inplace.lib		\
		$(SLB)$/misc.lib		\
        $(SLB)$/persist.lib \
        $(SLB)$/copied.lib

.IF "$(GUI)"=="WNT"
LIB1FILES+=$(SLB)$/ole.lib
.ENDIF

.IF "$(UPDATER)"==""
RESLIB1NAME=so
RESLIB1SRSFILES= $(SRS)$/src.srs
.ENDIF

SHL1TARGET= so$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= so2
SHL1STDLIBS=\
		$(SVTOOLLIB) \
		$(VCLLIB) \
		$(SVLLIB) \
		$(SOTLIB) \
		$(UNOTOOLSLIB) \
		$(TOOLSLIB)	\
		$(VOSLIB) \
		$(COMPHELPERLIB) \
		$(CPPUHELPERLIB) \
		$(CPPULIB) \
        $(SALLIB) \
        $(UCBHELPERLIB)

.IF "$(linkinc)" == ""
SHL1LIBS=	$(SLB)$/$(TARGET).lib
.ENDIF

.IF "$(GUI)"=="WNT"
SHL1STDLIBS+= \
			ole32.lib uuid.lib advapi32.lib gdi32.lib
.ENDIF

.IF "$(GUI)"=="WIN"
SHL1STDLIBS=$(VOSLIB) \
			ole2.lib compobj.lib storage.lib shell.lib \
			ole2disp.lib typelib.lib
.ENDIF

.IF "$(SOLAR_JAVA)" != ""
SHL1STDLIBS+=$(SJLIB)
.ENDIF

.IF "$(GUI)"=="UNX"
SHL1DEPN= $(LIB1TARGET)
.ELSE
SHL1DEPN= $(LIB1TARGET)
.ENDIF

.IF "$(linkinc)" == ""
.IF "$(GUI)"=="WNT"
SHL1OBJS+=	$(SLO)$/so2dll.obj					\
			$(SHLOBJECTS)

.ENDIF
SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

.ELSE			#"$(linkinc)" == ""
SHL11FILE=	$(MISC)$/data.slo
SHL12FILE=	$(MISC)$/dialog.slo
SHL13FILE=	$(MISC)$/inplace.slo
SHL14FILE=	$(MISC)$/misc.slo
.IF "$(GUI)"=="WNT"
SHL15FILE=	$(MISC)$/ole.slo
.ENDIF
SHL16FILE=	$(MISC)$/persist.slo
SHL17FILE=	$(MISC)$/solink.slo
.ENDIF

DEF1NAME	=$(SHL1TARGET)
DEF1DEPN	=$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =so2
DEF1DES 	=StarObjects

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk
.INCLUDE :  target.pmk


# --- SO2-Filter-Datei ---

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	@echo ------------------------------
	@echo Making: $@
	@echo WEP > $@
	@echo LIBMAIN >> $@
	@echo LibMain >> $@
	@echo CreateDdeExtern@SvBaseLink >> $@
	@echo RemoveDdeExtern@SvBaseLink >> $@
	@echo DataChanged@SvBaseLink >> $@
	@echo allocator >> $@
	@echo Exception >> $@
	@echo =@8 >> $@
	@echo __CT >> $@

