#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: unxsols3.mk,v $
#
#   $Revision: 1.30 $
#
#   last change: $Author: kz $ $Date: 2006/07/05 22:05:39 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************


ASM=/usr/ccs/bin/as
AFLAGS=-P -q


CDEFS+=-D_PTHREADS -DSYSV -DSUN -DSUN4 -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS -DSTLPORT_VERSION=400

SOLAR_JAVA*=TRUE
.IF "$(SOLAR_JAVA)"!=""
JAVADEF=-DSOLAR_JAVA
JAVAFLAGSDEBUG=-g
.IF "$(debug)"==""
JAVA_RUNTIME=-ljava
.ELSE
JAVA_RUNTIME=-ljava_g
.ENDIF
.ENDIF

# architecture dependent flags for the C and C++ compiler that can be changed by
# exporting the variable ARCH_FLAGS="..." in the shell, which is used to start build
ARCH_FLAGS*=

CXX*=CC
CC*=cc

CFLAGS=$(PREENVCFLAGS) -c -temp=/tmp
CFLAGSCC=-xCC $(ARCH_FLAGS)
CFLAGSCXX=-features=no%altspell,no%localfor $(ARCH_FLAGS)

CFLAGSEXCEPTIONS=
CFLAGS_NO_EXCEPTIONS=-noex

CFLAGSOBJGUIST=-KPIC
CFLAGSOBJCUIST=-KPIC
CFLAGSOBJGUIMT=-KPIC
CFLAGSOBJCUIMT=-KPIC
CFLAGSSLOGUIMT=-KPIC
CFLAGSSLOCUIMT=-KPIC
CFLAGSPROF=-xpg
CFLAGSDEBUG=-g
CFLAGSDBGUTIL=
CFLAGSOPT=-O
CFLAGSNOOPT=
CFLAGSOUTOBJ=-o

CFLAGSWARNCC=
CFLAGSWALLCC=+w2
CFLAGSWERRCC=-errwarn=%all

STDOBJVCL=$(L)$/salmain.o

THREADLIB=-lposix4
.IF "$(PURIFY)"!=""
LINK=/usr/local/purify-4.2-solaris2/purify CC
.ELSE
LINK*=CC
.ENDIF

# -z combreloc combines multiple relocation sections. Reduces overhead on startup
# -norunpath prevents the compiler from recording his own libs in the runpath
LINKFLAGS=-w -z combreloc -PIC -temp=/tmp -norunpath

# -z text force fatal error if non PIC code is linked into shared library. Such code 
#    would be expensive on startup
CHECKFORPIC =-z text
.IF "$(TARGETTHREAD)"=="MT"
#hack to get libthread.so linked first
LINKFLAGSAPPGUI=-lthread
LINKFLAGSAPPCUI=-lthread
LINKFLAGSSHLGUI=$(CHECKFORPIC) -G -lthread
LINKFLAGSSHLCUI=$(CHECKFORPIC) -G -lthread
.ELSE			# "$(TARGETTHREAD)"=="MT"
LINKFLAGSSHLGUI=$(CHECKFORPIC) -G
LINKFLAGSSHLCUI=$(CHECKFORPIC) -G
.ENDIF			# "$(TARGETTHREAD)"=="MT"

.IF "$(NO_BSYMBOLIC)"==""
.IF "$(PRJNAME)"!="schedule"
#.IF "$(PRJNAME)"!="envtest"
LINKFLAGSSHLGUI+=-Bsymbolic
LINKFLAGSSHLCUI+=-Bsymbolic
#.ENDIF
.ENDIF
.ENDIF				# "$(NO_BSYMBOLIC)"==""

# switches for dynamic and static linking
STATIC		= -Bstatic
DYNAMIC		= -Bdynamic

LINKFLAGSTACK=
LINKFLAGSPROF=-L$(COMPATH)/WS6U1/lib/libp -xpg -z allextract
LINKFLAGSDEBUG=
LINKFLAGSOPT=
LINKVERSIONMAPFLAG=-M
APPLINKSTATIC=-Bstatic
APPLINKSHARED=-Bdynamic
APP_LINKTYPE=

# reihenfolge der libs NICHT egal!
STDOBJGUI=
.IF "DBG_UTIL" != ""
STDSLOGUI=#-lpthread
.ELSE
STDSLOGUI=
.ENDIF
STDOBJCUI=
STDSLOCUI=
STDLIBGUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBCUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBGUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBCUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLGUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLCUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLGUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLCUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun

STDLIBGUIST+=-lX11
STDLIBGUIMT+=-lX11

LIBSTLPORT=$(DYNAMIC) -lstlport_sunpro
LIBSTLPORTST=$(STATIC) -lstlport_sunpro $(DYNAMIC)


LIBMGR=CC
LIBFLAGS=-xar -o 

IMPLIB=
IMPLIBFLAGS=

MAPSYM=
MAPSYMFLAGS=

RC=irc
RCFLAGS=-fo$@ $(RCFILES)
RCLINK=
RCLINKFLAGS=
RCSETVERSION=

DLLPOSTFIX=ss

DLLPRE=lib
DLLPOST=.so

LDUMP=cppfilt /b /n /o /p

CDEFS += -D_PTHREADS  
#CFLAGS += -U_REENTRANT -U_POSIX_PTHREAD_SEMANTICS
CFLAGSCXXSLO += -instances=static
CFLAGSCXXOBJ += -instances=static

LINKFLAGSAPPGUI+= -instances=static
LINKFLAGSSHLGUI+= -instances=static
LINKFLAGSAPPCUI+= -instances=static
LINKFLAGSSHLCUI+= -instances=static

